VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Shape Selection Tool"
   ClientHeight    =   3600
   ClientLeft      =   2670
   ClientTop       =   1935
   ClientWidth     =   4845
   Icon            =   "ShapeSel.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3600
   ScaleWidth      =   4845
   Begin VB.Frame Frame1 
      Caption         =   "Properties"
      Height          =   2415
      Left            =   3000
      TabIndex        =   5
      Top             =   120
      Width           =   1695
      Begin VB.ComboBox Combo1 
         Height          =   315
         Index           =   3
         ItemData        =   "ShapeSel.frx":000C
         Left            =   120
         List            =   "ShapeSel.frx":0022
         TabIndex        =   6
         Text            =   "Shape"
         Top             =   1800
         Width           =   1455
      End
      Begin VB.ComboBox Combo1 
         Height          =   315
         Index           =   2
         ItemData        =   "ShapeSel.frx":006A
         Left            =   120
         List            =   "ShapeSel.frx":0086
         TabIndex        =   3
         Text            =   "FillStyle"
         Top             =   1320
         Width           =   1455
      End
      Begin VB.ComboBox Combo1 
         Height          =   315
         Index           =   1
         ItemData        =   "ShapeSel.frx":00D2
         Left            =   120
         List            =   "ShapeSel.frx":00EE
         TabIndex        =   2
         Text            =   "BorderWidth"
         Top             =   840
         Width           =   1455
      End
      Begin VB.ComboBox Combo1 
         Height          =   315
         Index           =   0
         ItemData        =   "ShapeSel.frx":010D
         Left            =   120
         List            =   "ShapeSel.frx":0126
         TabIndex        =   1
         Text            =   "BorderStyle"
         Top             =   360
         Width           =   1455
      End
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   3465
      Index           =   0
      Left            =   120
      Picture         =   "ShapeSel.frx":016F
      ScaleHeight     =   3405
      ScaleWidth      =   2730
      TabIndex        =   0
      Top             =   0
      Width           =   2790
      Begin VB.Shape Shape1 
         BorderColor     =   &H00FF8080&
         BorderStyle     =   3  'Dot
         DrawMode        =   6  'Mask Pen Not
         FillColor       =   &H000000FF&
         Height          =   1815
         Index           =   0
         Left            =   600
         Top             =   1320
         Width           =   1575
      End
   End
   Begin VB.Label Label1 
      Caption         =   "Size and Move the Shape Tool with the mouse, or draw a new Shape."
      Height          =   855
      Left            =   3120
      TabIndex        =   4
      Top             =   2640
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'*********
' *Shape Selection Tool* by Chris
' This VB4-6 project demonstrates:
' Selecting/Sizing/Drawing with a Shape Tool
' ... aka "rubberband box"; see Mouse* code
'  a) DrawMode = vbInvert
'  b) BorderStyle = whatever
'  c) FillStyle = vbEmpty
'*********
Private Sizing As Boolean
Private Moving As Boolean
Private AnchorX As Single
Private AnchorY As Single
Private ShpL As Single
Private ShpT As Single

'NOTE:  This project assumes ScaleMode = vbTwips
Private Type SngRect
    Left As Single
    Top As Single
    Right As Single
    Bottom As Single
End Type
Private ShapeRect As SngRect

Private staticX As Boolean
Private staticY As Boolean

Private Const GAP As Single = 20
Private Sub GetShapeRect(ShapeObj As Shape)
    With ShapeRect
        .Left = ShapeObj.Left
        .Top = ShapeObj.Top
        .Right = .Left + ShapeObj.Width
        .Bottom = .Top + ShapeObj.Height
    End With
End Sub

' Return True if the mouse is over the Shape.
Private Function InShape(ByVal X As Single, ByVal Y As Single) As Boolean
    InShape = _
        (X >= ShapeRect.Left) And _
        (X <= ShapeRect.Right) And _
        (Y >= ShapeRect.Top) And _
        (Y <= ShapeRect.Bottom)
End Function


Private Sub Combo1_Click(Index As Integer)
Dim ndex As Integer

    ndex = Combo1(Index).ListIndex
    If ndex < 0 Then Exit Sub

    Select Case Index
    Case 0 ' borderstyle
        Shape1(0).BorderStyle = ndex
    Case 1 ' borderwidth
        ndex = Val(Combo1(Index).Text)
        If ndex < 1 Then ndex = 1
        Shape1(0).BorderWidth = ndex
    Case 2 ' fillstyle
        Shape1(0).FillStyle = ndex
    Case 3 ' shape
        Shape1(0).Shape = ndex
    End Select
End Sub

Private Sub Form_Load()
    GetShapeRect Shape1(0) 'init
End Sub





' Start dragging, resizing, or selecting a new area.
Private Sub Picture1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Select Case Picture1(Index).MousePointer
        Case vbSizeAll
            ' The mouse is over the center of the Shape.
            ' Start a drag.
            Moving = True
            AnchorX = X
            AnchorY = Y
            ShpL = ShapeRect.Left
            ShpT = ShapeRect.Top
        Case vbCrosshair
            ' The mouse is over nothing.
            ' Start a new area selection.
            Sizing = True
            AnchorX = X
            AnchorY = Y
            staticX = False
            staticY = False
            Shape1(0).Move X, Y, 2 * Screen.TwipsPerPixelX, 2 * Screen.TwipsPerPixelY
        Case Else
            ' The mouse is over an edge of the Shape.
            ' Start a new area selection.
            Sizing = True
            If (Abs(X - ShapeRect.Left) < GAP) Then AnchorX = ShapeRect.Right
            If (Abs(X - ShapeRect.Right) < GAP) Then AnchorX = ShapeRect.Left
            If (Abs(Y - ShapeRect.Top) < GAP) Then AnchorY = ShapeRect.Bottom
            If (Abs(Y - ShapeRect.Bottom) < GAP) Then AnchorY = ShapeRect.Top
    End Select
End Sub
' Size or move the Shape, or set the appropriate
' mouse pointer.
Private Sub Picture1_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim l As Single
Dim t As Single
Dim w As Single
Dim h As Single
Dim new_mouse_pointer As Integer
Dim near_left As Boolean
Dim near_right As Boolean
Dim near_top As Boolean
Dim near_bottom As Boolean

    If Moving Then
        ' Moving.
        l = ShpL + (X - AnchorX)
        t = ShpT + (Y - AnchorY)
        Shape1(0).Move l, t
    ElseIf Sizing Then
        ' Sizing.
        If staticX Then
            ' The X coordinate is static.
            l = Shape1(0).Left
            w = Shape1(0).Width
        Else
            ' The X coordinate can move.
            If X > AnchorX Then
                l = Shape1(0).Left
                w = X - AnchorX
            Else
                l = X
                w = AnchorX - X
            End If
        End If
        If staticY Then
            ' The Y coordinate is static.
            t = Shape1(0).Top
            h = Shape1(0).Height
        Else
            ' The Y coordinate can move.
            If Y > AnchorY Then
                t = Shape1(0).Top
                h = Y - AnchorY
            Else
                t = Y
                h = AnchorY - Y
            End If
        End If

        ' Position the Shape.
        Shape1(0).Move l, t, w, h
    Else
        ' Not moving or sizing.
        If Not InShape(X, Y) Then
            ' The mouse is not over the shape.
            new_mouse_pointer = vbCrosshair
        Else
            ' The mouse is over the Shape.
            ' Assume we can resize either X or Y.
            staticY = False
            staticX = False

            ' See which edges we're near.
            near_left = (Abs(X - ShapeRect.Left) < GAP)
            near_right = (Abs(X - ShapeRect.Right) < GAP)
            near_top = (Abs(Y - ShapeRect.Top) < GAP)
            near_bottom = (Abs(Y - ShapeRect.Bottom) < GAP)
            If (near_left And near_top) Or (near_right And near_bottom) Then
                ' Upper left or lower right corner.
                new_mouse_pointer = vbSizeNWSE
            ElseIf (near_left And near_bottom) Or (near_right And near_top) Then
                ' Upper right or lower left corner.
                new_mouse_pointer = vbSizeNESW
            ElseIf (near_left Or near_right) Then
                ' Left or right edge.
                new_mouse_pointer = vbSizeWE
                staticY = True
            ElseIf (near_top Or near_bottom) Then
                ' Top or bottom edge.
                new_mouse_pointer = vbSizeNS
                staticX = True
            Else
                ' Somewhere in the middle.
                new_mouse_pointer = vbSizeAll
            End If
        End If

        ' Don't change mouse if not necessary.
        If Picture1(Index).MousePointer <> new_mouse_pointer Then
            Picture1(Index).MousePointer = new_mouse_pointer
        End If
    End If
End Sub
' Finish moving or sizing.
Private Sub Picture1_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Sizing = False
    Moving = False
    GetShapeRect Shape1(0)
End Sub

